function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2;
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }
function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'transform-class-properties is enabled and runs after the decorators transform.'); }
/* eslint-disable no-param-reassign */

import { StateEffect, StateField } from '@codemirror/state';
import { Decoration, EditorView } from '@codemirror/view';
import { deepEqual } from '@difizen/libro-common';
import { LibroSearchUtils } from '@difizen/libro-search';
import { inject, transient } from '@difizen/mana-app';
import { prop } from '@difizen/mana-app';
/**
 * Helper class to highlight texts in a code mirror editor.
 *
 * Highlighted texts (aka `matches`) must be provided through
 * the `matches` attributes.
 */
export var CodeMirrorSearchHighlighter = (_dec = transient(), _dec2 = prop(), _dec3 = prop(), _dec(_class = (_class2 = /*#__PURE__*/function () {
  /**
   * Constructor
   *
   * @param editor The CodeMirror editor
   */
  function CodeMirrorSearchHighlighter(utils) {
    var _this = this;
    _classCallCheck(this, CodeMirrorSearchHighlighter);
    _initializerDefineProperty(this, "_currentIndex", _descriptor, this);
    _initializerDefineProperty(this, "_matches", _descriptor2, this);
    this.utils = utils;
    this._matches = new Array();
    this.currentIndex = undefined;
    this.highlightEffect = StateEffect.define({
      map: function map(value, mapping) {
        return {
          matches: value.matches.map(function (v) {
            return {
              text: v.text,
              position: mapping.mapPos(v.position)
            };
          }),
          currentIndex: value.currentIndex
        };
      }
    });
    this.highlightMark = Decoration.mark({
      class: 'cm-searchMatch'
    });
    this.selectedMatchMark = Decoration.mark({
      class: 'cm-searchMatch cm-searchMatch-selected libro-selectedtext'
    });
    this.highlightField = StateField.define({
      create: function create() {
        return Decoration.none;
      },
      update: function update(highlights, transaction) {
        highlights = highlights.map(transaction.changes);
        var _iterator = _createForOfIteratorHelper(transaction.effects),
          _step;
        try {
          var _loop = function _loop() {
            var ef = _step.value;
            if (ef.is(_this.highlightEffect)) {
              var e = ef;
              if (e.value.matches.length) {
                highlights = highlights.update({
                  add: e.value.matches.map(function (m, index) {
                    if (index === e.value.currentIndex) {
                      return _this.selectedMatchMark.range(m.position, m.position + m.text.length);
                    }
                    return _this.highlightMark.range(m.position, m.position + m.text.length);
                  }),
                  filter: function filter(from, to) {
                    return !e.value.matches.some(function (m) {
                      return m.position >= from && m.position + m.text.length <= to;
                    }) || from === to;
                  }
                });
              } else {
                highlights = Decoration.none;
              }
            }
          };
          for (_iterator.s(); !(_step = _iterator.n()).done;) {
            _loop();
          }
        } catch (err) {
          _iterator.e(err);
        } finally {
          _iterator.f();
        }
        return highlights;
      },
      provide: function provide(f) {
        return EditorView.decorations.from(f);
      }
    });
  }

  /**
   * Clear all highlighted matches
   */
  CodeMirrorSearchHighlighter = inject(LibroSearchUtils)(CodeMirrorSearchHighlighter, undefined, 0) || CodeMirrorSearchHighlighter;
  _createClass(CodeMirrorSearchHighlighter, [{
    key: "matches",
    get:
    /**
     * The list of matches
     */
    function get() {
      return this._matches;
    },
    set: function set(v) {
      if (!deepEqual(this._matches, v)) {
        this._matches = v;
      }
      this.refresh();
    }
  }, {
    key: "currentIndex",
    get: function get() {
      return this._currentIndex;
    },
    set: function set(v) {
      this._currentIndex = v;
      this.refresh();
    }
  }, {
    key: "clearHighlight",
    value: function clearHighlight() {
      this.currentIndex = undefined;
      this._highlightCurrentMatch();
    }

    /**
     * Clear the highlighted matches.
     */
  }, {
    key: "endQuery",
    value: function endQuery() {
      this._currentIndex = undefined;
      this._matches = [];
      if (this.cm) {
        this.cm.editor.dispatch({
          effects: this.highlightEffect.of({
            matches: [],
            currentIndex: undefined
          })
        });
        var selection = this.cm.state.selection.main;
        var from = selection.from;
        var to = selection.to;
        // Setting a reverse selection to allow search-as-you-type to maintain the
        // current selected match. See comment in _findNext for more details.
        if (from !== to) {
          this.cm.editor.dispatch({
            selection: {
              anchor: to,
              head: from
            }
          });
        }
      }
      return Promise.resolve();
    }

    /**
     * Highlight the next match
     *
     * @returns The next match if available
     */
  }, {
    key: "highlightNext",
    value: function highlightNext() {
      this.currentIndex = this._findNext(false);
      this._highlightCurrentMatch();
      return Promise.resolve(this.currentIndex !== undefined ? this._matches[this.currentIndex] : undefined);
    }

    /**
     * Highlight the previous match
     *
     * @returns The previous match if available
     */
  }, {
    key: "highlightPrevious",
    value: function highlightPrevious() {
      this.currentIndex = this._findNext(true);
      this._highlightCurrentMatch();
      return Promise.resolve(this.currentIndex !== undefined ? this._matches[this.currentIndex] : undefined);
    }

    /**
     * Set the editor
     *
     * @param editor Editor
     */
  }, {
    key: "setEditor",
    value: function setEditor(editor) {
      this.cm = editor;
      this.refresh();
      if (this.currentIndex !== undefined) {
        this._highlightCurrentMatch();
      }
    }
  }, {
    key: "_highlightCurrentMatch",
    value: function _highlightCurrentMatch() {
      if (!this.cm) {
        // no-op
        return;
      }

      // Highlight the current index
      if (this.currentIndex !== undefined) {
        var match = this.matches[this.currentIndex];
        // this.cm.editor.focus();
        this.cm.editor.dispatch({
          selection: {
            anchor: match.position,
            head: match.position + match.text.length
          },
          scrollIntoView: true
        });
      } else {
        // Set cursor to remove any selection
        this.cm.editor.dispatch({
          selection: {
            anchor: 0
          }
        });
      }
    }
  }, {
    key: "refresh",
    value: function refresh() {
      if (!this.cm) {
        // no-op
        return;
      }
      var effects = [this.highlightEffect.of({
        matches: this.matches,
        currentIndex: this.currentIndex
      })];
      if (!this.cm.state.field(this.highlightField, false)) {
        effects.push(StateEffect.appendConfig.of([this.highlightField]));
      }
      this.cm.editor.dispatch({
        effects: effects
      });
    }
  }, {
    key: "_findNext",
    value: function _findNext(reverse) {
      if (this.matches.length === 0) {
        // No-op
        return undefined;
      }
      // In order to support search-as-you-type, we needed a way to allow the first
      // match to be selected when a search is started, but prevent the selected
      // search to move for each new keypress.  To do this, when a search is ended,
      // the cursor is reversed, putting the head at the 'from' position.  When a new
      // search is started, the cursor we want is at the 'from' position, so that the same
      // match is selected when the next key is entered (if it is still a match).
      //
      // When toggling through a search normally, the cursor is always set in the forward
      // direction, so head is always at the 'to' position.  That way, if reverse = false,
      // the search proceeds from the 'to' position during normal toggling.  If reverse = true,
      // the search always proceeds from the 'anchor' position, which is at the 'from'.

      var cursor = this.cm.state.selection.main;
      var lastPosition = reverse ? cursor.anchor : cursor.head;
      if (lastPosition === 0 && reverse && this.currentIndex === undefined) {
        // The default position is (0, 0) but we want to start from the end in that case
        lastPosition = this.cm.doc.length;
      }
      var position = lastPosition;
      var found = this.utils.findNext(this.matches, position, 0, this.matches.length - 1);
      if (found === undefined) {
        // Don't loop
        return reverse ? this.matches.length - 1 : undefined;
      }
      if (reverse) {
        found -= 1;
        if (found < 0) {
          // Don't loop
          return undefined;
        }
      }
      return found;
    }
  }]);
  return CodeMirrorSearchHighlighter;
}(), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "_currentIndex", [_dec2], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
}), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "_matches", [_dec3], {
  configurable: true,
  enumerable: true,
  writable: true,
  initializer: null
})), _class2)) || _class);