import { LibroSearchModule } from '@difizen/libro-search';
import { ManaModule } from '@difizen/mana-app';
import { CodeMirrorCodeCellSearchProviderContribution } from "./codemirror-code-cell-search-provider-contribution.js";
import { CodeMirrorCodeCellSearchProvider } from "./codemirror-code-cell-search-provider.js";
import { CodeMirrorSearchHighlighter } from "./codemirror-search-highlighter.js";
import { CodeMirrorCodeCellSearchOption, CodeMirrorCodeCellSearchProviderFactory, CodeMirrorSearchHighlighterFactory } from "./codemirror-search-protocol.js";
export var SearchCodemirrorCellModule = ManaModule.create().register(CodeMirrorCodeCellSearchProvider, CodeMirrorSearchHighlighter, CodeMirrorCodeCellSearchProviderContribution, {
  token: CodeMirrorSearchHighlighterFactory,
  useFactory: function useFactory(ctx) {
    return function (editor) {
      var child = ctx.container.createChild();
      var highlighter = child.get(CodeMirrorSearchHighlighter);
      highlighter.setEditor(editor);
      return highlighter;
    };
  }
}, {
  token: CodeMirrorCodeCellSearchProviderFactory,
  useFactory: function useFactory(ctx) {
    return function (options) {
      var child = ctx.container.createChild();
      child.register({
        token: CodeMirrorCodeCellSearchOption,
        useValue: options
      });
      var model = child.get(CodeMirrorCodeCellSearchProvider);
      return model;
    };
  }
}).dependOn(LibroSearchModule);